/*
 * JavaBotSimNoGraphics.java
 */

package JavaBotSim;

import java.io.*;
import EDU.gatech.cc.is.abstractrobot.*;
import EDU.gatech.cc.is.clay.*;
import EDU.gatech.cc.is.util.*;

/**
 * Application that runs a control system in simulation with no graphics.
 * <P>
 * To run this program, first ensure you are in the correct directory (where
 * the JavaBotSimNoGraphics.class file is), then type 
 * "java JavaBotSimNoGraphics".
 * <P>
 * For more detailed information, see the
 * <A HREF="../../../../../JavaBotSim/docs/index.html">JavaBotSim page</A>.
 * <P>
 * <A HREF="../COPYRIGHT.html">Copyright</A> 
 * (c)1997 Georgia Tech Research Corporation
 *
 * @author Tucker Balch
 * @version $Revision: 1.1 $
 */

public class JavaBotSimNoGraphics
	{
	private static SimulationCanvas simulation;
	private static String	dsc_file;

        /**
	 * Main for JavaBotSim.
         */
	public static void main(String[] args)
		{
		/*--- check the arguments ---*/
		if (args.length == 1)
			{
			if (args[0].equalsIgnoreCase("-version"))
				{
				System.out.println(
					JavaBotsVersion.longReport());
				System.exit(0);
				}
			else
				{
				dsc_file=args[0];

				/*--- tell the simulation to load and run ---*/
				System.out.println(
					JavaBotsVersion.shortReport());
				simulation =
					new SimulationCanvas(null,0,0,dsc_file);
				simulation.reset();
				if (simulation.descriptionLoaded())
					// only if loaded ok.
					{
					simulation.start();
					}
				}
			}
		else
			{
			System.out.println(
				"usage: JavaBotSimNoGraphics [-version] descriptionfile");
			}
		}
	}
