// This is an example description file for specifying the environment
// when using JavaBotSim.  


// bounds statements set the bounds of the visible "playing field" in
// a simulation.   If the aspect ratio of the bounds are not the same 
// as the graphical area set aside by the simulation, then the robots 
// may wander off the screen.  This will be fixed (eventually!)
// FORMAT: bounds left right bottom top

//bounds -4 4 -4 4
bounds -2 2 -2 2


// A background statement sets the background color for the simulation.
// Here is a nice gray color.
// FORMAT: background color

background xFFFFFF


// robot statements cause a robot with a control system to be instantiated
// in the simulation.  Be sure to include the full class name for the
// abstract robot type and your control system.  The x y and theta
// parameters set the initial position of the robot in the field.
// You can used different colors to tell robots apart from one another.
// FORMAT: robot robottype controlsystem x y theta forecolor backcolor 
//		visionclass

robot EDU.gatech.cc.is.abstractrobot.PebblesSim 
	play 0  1.5 0 x000000 xFF0000 2 

// obstacles
object EDU.gatech.cc.is.simulation.ObstacleSim -2.0 -1.0 0 0.30 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 2.0 2.0 0 0.10 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 2.3 1.8 0 0.30 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim -3  3 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 3  -3.5 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 3.5 -2 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim -3.5 -2 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 3.5 -2 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim -3.0 1.5 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 2.0 -1.2 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 1.0 2.0 0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim 0.0 -4  0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim -1.0 2.2  0 0.25 xC0C0C0 x000000 2
object EDU.gatech.cc.is.simulation.ObstacleSim -2.0 4.5 0 0.25 xC0C0C0 x000000 2

// the Green Ball
object EDU.gatech.cc.is.simulation.SquiggleBallSim 
	1.5 1.00 0 0.2 x00FF00 x000000 1 

// Red Balls
object EDU.gatech.cc.is.simulation.SquiggleBallSim 
	-0.9 1.80 0 0.2 xFFA000 x000000 0
object EDU.gatech.cc.is.simulation.SquiggleBallSim 
	0.9 -3.60 0 0.2 xFFA000 x000000 0


//object DeadMartianSim 0 0 FFFE00

